Scriptname REQ_MassEffectField extends ActiveMagicEffect
{This script dynamically adds armor-dependent mass bonuses to all humanoid NPCs}

Float massmod = 0.0
Actor npc
Bool working = False
Bool shutdown = False


Event OnEffectStart(actor Target, actor Caster)
	npc = Target
	GoToState("StartEvaluation")
EndEvent

Event OnObjectEquipped(Form akBaseObject, ObjectReference akReference)
	GoToState("StartEvaluation")
EndEvent

Event OnObjectUnEquipped(Form akBaseObject, ObjectReference akReference)
	GoToState("StartEvaluation")
EndEvent

Event OnEffectFinish(actor Target, actor Caster)
	shutdown = True
	GotoState("")
	; clean up the mass, just to make sure we do not get supermassive NPCs
	Target.ModAV("mass",-massmod)
	Target.ModAV("speedmult",massmod*50)
EndEvent

State StartEvaluation

	Event OnObjectUnEquipped(Form akBaseObject, ObjectReference akReference)
	EndEvent
	
	Event OnObjectEquipped(Form akBaseObject, ObjectReference akReference)
	EndEvent

	Event OnUpdate()
		If !working && !shutdown
			UnregisterForUpdate()
			GoToState("EvaluateArmor")
		EndIf
	EndEvent
	
	Event OnBeginState()
		UnregisterForUpdate()
		RegisterForUpdate(1)
	EndEvent

EndState

State EvaluateArmor

	Event OnObjectUnEquipped(Form akBaseObject, ObjectReference akReference)
		GoToState("StartEvaluation")
	EndEvent
	
	Event OnObjectEquipped(Form akBaseObject, ObjectReference akReference)
		GoToState("StartEvaluation")
	EndEvent
	
	Event OnBeginState()
		working = True
		AdjustMass()
		If ( GetState() == "EvaluateArmor" )
			GoToState("")
		EndIf
		working = False
	EndEvent
	
EndState

Function AdjustMass()
	Float Oldmass = npc.getAV("mass")
	Float OldSpeed = npc.getAV("speedmult")
	Armor[] slots = new Armor[32]
	Armor nextitem
	weapon armed
	Int i = 61
	Int index = 0
	Float oldmassmod = massmod
	Float interim = 0.0
	Float newmassmod = 0.0
	While i >= 30
		nextitem = npc.GetWornForm(Armor.GetMaskForSlot(i)) as Armor
		If nextitem != None && slots.rfind(nextitem,index) == -1 
			slots[index] = nextitem
			If nextitem.GetWeight() > 0.0
				interim = newmassmod
				newmassmod += nextitem.GetWeight()
			EndIf
			index += 1
		Endif
		i -= 1
	EndWhile
	armed = npc.GetEquippedWeapon(False)
	If (armed != None)
		interim = newmassmod
		newmassmod += armed.GetWeight()
		i = armed.GetWeaponType()
	EndIf
	if (i < 5 || armed == None)
		armed = npc.GetEquippedWeapon(True)
		If (armed != None)
			interim = newmassmod
			newmassmod += armed.GetWeight()
		Endif
	Endif
	newmassmod /= 100.0
	If !shutdown
		massmod = newmassmod
		npc.ModAV("mass",massmod-oldmassmod)
		npc.ModAV("speedmult",(oldmassmod-massmod)*50)
	EndIf
EndFunction
