Scriptname REQ_AttributeSystem extends REQ_PlayerAlias
{This script controls the derived attributes, they are updated each time the skills menu is closed.}

String[] Property derived Auto
{list of derived stats to mod, attackdamagemult must come before any weaponskillmods!}
Float[] Property prefactor Auto
Float[] Property weight_health Auto
Float[] Property weight_magicka Auto
Float[] Property weight_stamina Auto
Float[] Property threshold Auto
Bool[] Property rescale Auto

Float[] Property Modifiers Auto
Float[] Property Mods_display Auto
Float[] Property Mods_Shout Auto
Float[] Property Shout_Thresholds Auto
Bool doagain = False
Bool shortcut = False

REQ_MCM_Skills Property mcm Auto

Event ScriptShutDown(string eventName, string strArg, float numArg, Form sender)
	Player.ModAV("ShoutRecoveryMult", -0.5)
	Evaluate_Attributes(True)
	UnregisterForAllMenus()
	REQ_AutoUpdater UpdateControl = GetOwningQuest().GetAlias(0) as REQ_AutoUpdater
	Int index = UpdateControl.Scripts.find(self)
	UpdateControl.ShutdownReady[index] = True
EndEvent

Event ScriptInit(string eventName, string strArg, float numArg, Form sender)
	Player.ModAV("ShoutRecoveryMult", 0.5)
	Evaluate_Attributes(False)
	mcm.modname = "$REQ_modname_skills"
	mcm.pages = new String[2]
	mcm.pages[0] = "$REQ_cat_skill0"
	mcm.pages[1] = "$REQ_cat_skill1"
	mcm.player = Player
	RegisterForMenu("StatsMenu")
	RegisterForMenu("MagicMenu")
	REQ_AutoUpdater UpdateControl = GetOwningQuest().GetAlias(0) as REQ_AutoUpdater
	Int index = UpdateControl.Scripts.find(self)
	UpdateControl.ShutdownReady[index] = False
EndEvent

Event OnPlayerLoadGame()
	;this should be unnecessary and is a security addition
	UnregisterForAllMenus()
	RegisterForMenu("StatsMenu")
	RegisterForMenu("MagicMenu")
EndEvent

Event OnMenuClose(String Menu)
	GoToState("working")
	shortcut = (Menu == "MagicMenu")
	Evaluate_Attributes(False)
EndEvent

State working
	Event OnMenuClose(String Menu)
		shortcut = (Menu == "MagicMenu")
		doagain = True
	EndEvent
EndState

Function Evaluate_Attributes(Bool Shutdown=False)
	Int i = 0
	int j = derived.find("AttackDamageMult")
	Float magicka = Player.GetBaseAV("Magicka")
	Float stamina = Player.GetBaseAV("Stamina")
	Float health = Player.GetBaseAV("Health")
	Float weighted = 0.0
	If !shortcut
		While i < derived.length
			Player.ModAV(derived[i], -Modifiers[i])
			Modifiers[i] = 0.0
			Mods_display[i] = 0.0
			If !Shutdown
				weighted = weight_health[i] * health + weight_magicka[i] * magicka + weight_stamina[i] * stamina
				If weighted > threshold[i]
					Modifiers[i] = prefactor[i] * Math.Pow(weighted - threshold[i], 0.5)
					Mods_display[i] = Modifiers[i]
				EndIf
				If rescale[i]
					Modifiers[i] = 100 / (1 + Modifiers [j] ) + Modifiers[i] / (1 + Modifiers[j] ) - 100
				EndIf
				Player.ModAV(derived[i], Modifiers[i])
			EndIf
			i += 1
		EndWhile
	EndIf
	Player.ModAV("ShoutRecoveryMult", Mods_Shout[0])
	Mods_Shout[1] = 0.0
	Mods_Shout[2] = 0.0
	Mods_Shout[3] = 0.0
	If Game.QueryStat("Times Shouted") > Shout_Thresholds[1]
		Mods_Shout[1] = 0.005 * Math.Pow(Game.QueryStat("Times Shouted") - Shout_Thresholds[1], 0.5)
	EndIf
	If Game.QueryStat("Words Of Power Learned") > Shout_Thresholds[2]
		Mods_Shout[2] = 0.02 * Math.Pow(Game.QueryStat("Words Of Power Learned") - Shout_Thresholds[2], 0.5)
	EndIf
	If Game.QueryStat("Words Of Power Unlocked") > Shout_Thresholds[3]
		Mods_Shout[3] = 0.05 * Math.Pow(Game.QueryStat("Words Of Power Unlocked") - Shout_Thresholds[3], 0.5)
	EndIf
	Mods_Shout[0] = Mods_Shout[1] + Mods_Shout[2] + Mods_Shout[3]
	Player.ModAV("ShoutRecoveryMult", -Mods_Shout[0])	
	If doagain
		doagain = False
		Evaluate_Attributes(False)
	EndIf
	GotoState("")
EndFunction
