Scriptname REQ_AutoUpdater extends ReferenceAlias
{auto-update routine for scripts attached to the player via quest alias}

Bool[] Property ShutdownReady Auto
{status of the individual scripts, should initially contain only True}
Alias[] Property Aliases Auto
{a list of all aliases managed by this Update-Manager}
REQ_PlayerAlias[] Property Scripts Auto
{a list of all scripts managed by this Update-Manager; needs same length as Aliases but none entries}

GlobalVariable Property Version Auto
GlobalVariable Property VersionInstalled Auto
Message Property BeginUpdate Auto
Message Property FinishUpdate Auto

Function InitScripts()
	Int count = 0
	While (count < Scripts.Length)
		Scripts[count] = Aliases[count] as REQ_PlayerAlias
		Scripts[count].RegisterForModEvent("ScriptShutDown", "ScriptShutDown")
		Scripts[count].RegisterForModEvent("ScriptInit", "ScriptInit")
		count += 1
	EndWhile
	SendModEvent("ScriptInit")
	RegisterForUpdate(1)
EndFunction

Event OnPlayerLoadGame()
	Int count = 0
	While (count < Scripts.Length)
		Scripts[count].RegisterForModEvent("ScriptShutDown", "ScriptShutDown")
		Scripts[count].RegisterForModEvent("ScriptInit", "ScriptInit")
		count += 1
	EndWhile
	; count = 0
	If (GetOwningQuest() as REQ_QuestRestarter).SKSECheck()
		If ( Version.GetValue() > VersionInstalled.GetValue() )
			SendModEvent("ScriptShutDown")
			Self.GotoState("ShutDown")
			RegisterForUpdate(1)
			BeginUpdate.Show()
		EndIf
	EndIf
EndEvent

State Shutdown

	Event OnUpdate()
		If ( ShutdownReady.find(False) < 0 )
			Self.GotoState("")
			UnregisterForUpdate()
			Game.SetGameSettingFloat("fLevelUpCarryWeightMod",0.0)
			(GetOwningQuest() as REQ_QuestRestarter).Restart()
		EndIf
	EndEvent
	
EndState

Event OnUpdate()
	If ( ShutdownReady.find(True) < 0 )
		UnregisterForUpdate()
		VersionInstalled.SetValue(Version.GetValue())
		FinishUpdate.Show()
	EndIf
EndEvent
