Scriptname REQ_QuestRestarter extends Quest
{script state manager for player-ref scripts quest}

ReferenceAlias Property AutoUpdater Auto
{ref alias with AutoUpdater script attached}
Actor Property Stalker Auto
{the invisible and invincible guy following you all the time}
Message Property Install Auto
Message Property SKSE_missing Auto
{message to display if SKSE is missing at all}
Message Property SKSE_broken Auto
{message if SKSE dll and script versions differ}

;stops the quest, wait a few seconds and restart it to update all alias scripts
Function Restart()
	Self.Stop()
	Utility.Wait(1)
	Self.Start()
	Utility.Wait(1)
	(AutoUpdater as REQ_AutoUpdater).InitScripts()
EndFunction

Event OnStoryChangeLocation(ObjectReference akActor, Location akOldLocation, Location akNewLocation)
	If ( !SKSECheck() )
		Self.Stop()
	ElseIf (akOldLocation != None)
		Utility.Wait(1)
		Install.Show()
		(AutoUpdater as REQ_AutoUpdater).InitScripts()
	Else
		Self.Stop()
	EndIf
EndEvent

Bool Function SKSECheck()
	Int version_skse = SKSE.GetVersionRelease()
	Int version_script = SKSE.GetScriptVersionRelease()
	If (version_skse == 0 || version_script == 0)
		SKSE_missing.Show()
		return False
	ElseIf (version_skse != version_script )
		SKSE_broken.Show(version_skse as Float, version_script as Float)
		return False
	Else
		Return True
	EndIf
EndFunction
